#include <amxmodx>
#include <reapi>
#include <hamsandwich>
#include <revive_teammates>
// #include <aes_v>

new const SECTION[] = "bonuses";

new g_iCvarFrags,
	g_iCvarRestoreDeath,
	g_iCvarKevlarType,
	g_iCvarHealthMaxMode,
	Float:g_fCvarSpawnHealth,
	Float:g_fCvarBonusHealth,
	Float:g_fCvarProtectionTime,
#if defined AES_MAX_LEVEL_LENGTH
	g_iCvarExperience,
	g_iCvarAnew,
#endif
	g_sCvarWeapons[256];

public plugin_init()
{
	register_plugin("RT: Bonuses", RT_VERSION_STR, "Emma Jule");
}

public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonBonuses;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonBonuses = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonBonuses = json_init_object();
	}
	
	if (json_is_object(jsonBonuses))
	{
		json_cvar_integer(jsonBonuses, "frags", 0, "Фрагов за поднятие тиммейта", .cvar = g_iCvarFrags);
		json_cvar_integer(jsonBonuses, "restore_death", 0, "Обнулить очко смерти воскрешенному игроку", .cvar = g_iCvarRestoreDeath);
		json_cvar_float(jsonBonuses, "spawn_health", 0.0, "Количество здоровья с которым появится воскрешенный игрок", .has_max = true, .max_val = 255.0, .cvar = g_fCvarSpawnHealth);
		json_cvar_integer(jsonBonuses, "give_kevlar", 0, "Выдавать броню?^n0 - Нет^n1 - Бронижелет^n2 - Бронижелет с каской", .has_min = true, .has_max = true, .max_val = 2, .cvar = g_iCvarKevlarType);
		json_cvar_float(jsonBonuses, "bonus_health", 0.0, "Количество бонусного здоровья за поднятие тиммейта", .cvar = g_fCvarBonusHealth);
		json_cvar_float(jsonBonuses, "protection", 0.0, "Защита после спавна (в секундах)^nВ этот период воскрешенного игрока не смогут убить!", .has_max = true, .max_val = 5.0, .cvar = g_fCvarProtectionTime);
		json_cvar_integer(jsonBonuses, "health_limit_control", 0, "Здоровье не привысит максимальное здоровье игрока^nДопустим по умолчанию максимальное здоровье 100, бонусное здоровье не сможет привысить этот параметр^nЭто также будет учитывать некоторые плагины по типу лечебная граната, шприц..", .cvar = g_iCvarHealthMaxMode);
#if defined AES_MAX_LEVEL_LENGTH
		json_cvar_integer(jsonBonuses, "aes_exp", 0, "Опыт EXP за поднятие тиммейта", .cvar = g_iCvarExperience);
		json_cvar_integer(jsonBonuses, "aes_anew", 0, "Очки ANEW за поднятие тиммейта", .cvar = g_iCvarAnew);
#endif
		json_cvar_string(jsonBonuses, "weapons", "knife deagle", "Список оружий с которым заспавнится воскрешенный игрок^nПримечание: вводите через пробел и без weapon_", .cvar = g_sCvarWeapons, .len = charsmax(g_sCvarWeapons));
		
		json_object_set_value(jsonMain, SECTION, jsonBonuses);
		json_free(jsonBonuses);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public RT_GotRespawn(const id, const friend)
{
	if (g_iCvarFrags)
	{
		ExecuteHamB(Ham_AddPoints, friend, g_iCvarFrags, false);
	}
	
	if (g_fCvarBonusHealth > 0.0)
	{
		rg_add_health(friend, g_fCvarBonusHealth, bool:g_iCvarHealthMaxMode);
	}
	
#if defined AES_MAX_LEVEL_LENGTH
	if (g_iCvarExperience)
	{
		aes_add_player_exp_f(friend, g_iCvarExperience);
	}
	
	if (g_iCvarAnew)
	{
		aes_add_player_bonus_f(friend, g_iCvarAnew);
	}
#endif
	
	if (g_iCvarRestoreDeath)
	{
		set_member(id, m_iDeaths, max(get_member(id, m_iDeaths) - 1, 0));
	}
	
	if (g_fCvarSpawnHealth)
	{
		set_entvar(id, var_health, g_fCvarSpawnHealth);
		
		if (g_iCvarHealthMaxMode)
		{
			set_entvar(id, var_max_health, g_fCvarSpawnHealth);
		}
	}
	
	if (g_fCvarProtectionTime > 0.0)
	{
		set_member(id, m_flSpawnProtectionEndTime, get_gametime() + g_fCvarProtectionTime);
	}
	
	if (g_iCvarKevlarType)
	{
		rg_set_user_armor(id, 100, ArmorType:g_iCvarKevlarType);
	}
	
	if (g_sCvarWeapons[0])
	{
		// set_member(id, m_bNotKilled, true);
		rg_remove_all_items(id);
		rg_give_items(id, g_sCvarWeapons);
	}
}

stock rg_give_random_item(const id, GiveType:type = GT_APPEND)
{
	new reference[24], i;
	
	do {
		i = random_num(CSW_P228, CSW_LAST_WEAPON);
	}
	while
	(
		~CSW_ALL_GUNS & (1 << i)
	);
	
	rg_get_weapon_info(i, WI_NAME, reference, charsmax(reference));
	rg_give_item(id, reference, type);
}

stock rg_give_items(const id, references[], bool:full_ammo = true)
{
	new item;
	new weapon[17];
	new size = strlen(references) - 1;
	
	while (argbreak(references, weapon, charsmax(weapon), references, size) != -1)
	{
		item = rg_give_item(id, fmt("weapon_%s", weapon));
		
		if (item > 0 && full_ammo)
		{
			set_member(id, m_rgAmmo,
				rg_get_weapon_info(get_member(item, m_iId), WI_MAX_ROUNDS),
				rg_get_weapon_info(get_member(item, m_iId), WI_AMMO_TYPE)
			);
		}
	}
}

stock rg_add_health(const id, const Float:hp, bool:obey_max = true)
{
	new Float:health = Float:get_entvar(id, var_health);
	new Float:max_health = Float:get_entvar(id, var_max_health);
	
	if (obey_max)
	{
		// Если у игрока здоровья больше чем должно то плагин не должен сбросить его до max_health
		if (health >= max_health && hp > 0.0)
			return;
		
		set_entvar(id, var_health, floatclamp(health + hp, 1.0, max_health));
	}
	else
		set_entvar(id, var_health, floatmax(health + hp, 1.0));
}
