#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <reapi>
#include <revive_teammates_const>

new Float:g_fCvarDuration,
	g_sCvarChatPrefix[48],
	g_sCvarSize[64];
	
new g_iForward_ParseCfg,
	g_iForward_Loot_Pre,
	g_iForward_Loot_Post,
	g_iForward_Loot_Ended,
	g_iForward_Loot_Think,
	g_iForward_StartSneaking,
	g_iForward_StopSneaking,
	g_iForward_Player_Spawn_Post,
	g_iForward_Return;

new bool:g_eRelation[RelationStatus];
new bool:g_bIsActionRightNow[33];
new Float:g_vecMins[3], Float:g_vecMaxs[3];
new g_pCorpse[33];

new FreeForAll;
// new Trie:g_tCvars;

public plugin_natives()
{
	register_library("revive_teammates");
	
	register_native("RT_GetPrefix", "Native_RT_GetPrefix");
	register_native("RT_GetCorpse", "Native_RT_GetCorpse");
	register_native("RT_DeleteCorpse", "Native_RT_DeleteCorpse");
	register_native("RT_IsUsing", "Native_RT_IsUsingCorpse");
	
	register_native("RT_GoAction", "Native_RT_GoAction");
	register_native("RT_BreakAction", "Native_RT_BreakAction");
	
	register_native("RT_Get_Relation", "Native_RT_Get_Relation");
	register_native("RT_Set_Relation", "Native_RT_Set_Relation");
	register_native("RT_RelationShipStatus", "Native_RT_RelationShipStatus");
}

public plugin_precache()
{
	register_plugin("[WIP] Revive Die Players", RT_VERSION_STR, "Emma Jule");
	register_dictionary("revive_teammates.txt");
	
	g_iForward_ParseCfg = CreateMultiForward("RT_ParseConfigFile", ET_IGNORE, FP_CELL);
	// g_tCvars = TrieCreate();
	
	if (!parse_cfg())
		set_fail_state("Something went wrong! Check plugin settings!");
}

public plugin_init()
{
	register_event("TeamInfo", "Event_TeamInfo", "a", "1>0");
	register_message(get_user_msgid("ClCorpse"), "Messsage_ClCorpse");
	
	// RegisterHam(Ham_ObjectCaps, "info_target", "CBaseEntity_ObjectCaps", false);
	RegisterHam(Ham_StopSneaking, "info_target", "CBaseEntity_StopSneaking", true);
	
	DestroyForward(g_iForward_ParseCfg);
	g_iForward_Loot_Pre = CreateMultiForward("RT_StartLoot_Pre", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL);
	g_iForward_Loot_Post = CreateMultiForward("RT_StartLoot_Post", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_FLOAT);
	g_iForward_Loot_Ended = CreateMultiForward("RT_StopLoot", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL);
	g_iForward_Loot_Think = CreateMultiForward("RT_ThinkLoot", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_FLOAT, FP_VAL_BYREF);
	g_iForward_StartSneaking = CreateMultiForward("RT_StartSneaking", ET_CONTINUE, FP_CELL, FP_CELL, FP_ARRAY);
	g_iForward_StopSneaking = CreateMultiForward("RT_StopSneaking", ET_IGNORE, FP_CELL, FP_CELL);
	g_iForward_Player_Spawn_Post = CreateMultiForward("RT_GotRespawn", ET_IGNORE, FP_CELL, FP_CELL);
	
	new pCvarFreeForAll = get_cvar_pointer("mp_freeforall");
	bind_pcvar_num(pCvarFreeForAll, FreeForAll);
	hook_cvar_change(pCvarFreeForAll, "cvar_change_callback");
}

public plugin_cfg()
{
	new size[6][7];
	
	if (
		parse(g_sCvarSize,
			size[0], charsmax(size[]), 
			size[1], charsmax(size[]),
			size[2], charsmax(size[]),
			size[3], charsmax(size[]),
			size[4], charsmax(size[]),
			size[5], charsmax(size[])
		) == sizeof(size)
	)
	{
		for (new i; i < 3; i++)
		{
			if (
				(g_vecMins[i] = str_to_float(size[i])) > 0.0
				|| (g_vecMaxs[i] = str_to_float(size[i + 3])) < 0.0
			) {
				goto @def
			}
		}
	}
	else
	{
		@def:
		g_vecMins = DEFAULT_CORPSE_MINS;
		g_vecMaxs = DEFAULT_CORPSE_MAXS;
	}
}

public Event_TeamInfo()
{
	// CHalfLifeMultiplay::InitHUD
	// CHalfLifeMultiplay::ClientDisconnected
	// CBasePlayer::Spawn
	// CBasePlayer::SwitchTeam
	// CBasePlayer::GetIntoGame
	UTIL_CorpseRemove(read_data(1));
}

public client_putinserver(id)
{
	g_bIsActionRightNow[id] = false;
}

public CBaseEntity_StopSneaking(const this)
{
	if (!FClassnameIs(this, CORPSE_CLASSNAME))
		return;
	
	new owner = get_entvar(this, var_owner);
	new activator = get_entvar(this, var_activator);
	
	if (VALID_PLAYER(activator))
	{
		// It's no problem to kill server
		BreakAction(this, activator, owner, false);
	}
	
	// forward RT_StopSneaking(const corpse_id, const owner);
	ExecuteForward(g_iForward_StopSneaking, _, this, owner);
}

public Corpse_Think(id)
{
	new pActivator = get_entvar(id, var_activator);
	new pOwner = get_entvar(id, var_owner);
	
	if (VALID_PLAYER(pActivator) && !is_user_alive(pActivator))
	{
		BreakAction(id, pActivator, pOwner, false);
		return;
	}
	
	new Float:fTimeEnd;
	new Float:fGameTime = get_gametime();
	get_entvar(id, var_timer, fTimeEnd);
	if ((fTimeEnd != 0.0 && fGameTime >= fTimeEnd))
	{
		BreakAction(id, pActivator, pOwner, true);
		return;
	}
	
	// forward RT_ThinkLoot(const corpse_id, const activator, const owner, Float:time_ending, &nextthink);
	new Float:fNextTime = 0.1;
	ExecuteForward(g_iForward_Loot_Think, g_iForward_Return, id, pActivator, pOwner, fTimeEnd, fNextTime);
	if (g_iForward_Return > RT_CONTINUE)
	{
		BreakAction(id, pActivator, pOwner, false);
		return;
	}
	else
		set_entvar(id, var_nextthink, fGameTime + fNextTime);
}

BreakAction(const corpse, const activator, const owner, const bool:complete)
{
	g_bIsActionRightNow[activator] = false;
	
	// forward RT_StopLoot(const corpse_id, const activator, const owner, bool:complete);
	ExecuteForward(g_iForward_Loot_Ended, g_iForward_Return, corpse, activator, owner, complete);
	
	if (complete && g_iForward_Return == RT_CONTINUE)
	{
		rg_round_respawn(owner);
		
		// forward RT_GotRespawn(const id, const friend);
		ExecuteForward(g_iForward_Player_Spawn_Post, _, owner, activator);
	}
	
	if (!is_nullent(corpse))
	{
		set_entvar(corpse, var_activator, 0);
		set_entvar(corpse, var_timer, 0.0);
		set_entvar(corpse, var_nextthink, 0.0);
	}
}

// Создание трупа
public Messsage_ClCorpse()
{
	new corpse_id = rg_create_entity("info_target");
	if (is_nullent(corpse_id))
		return PLUGIN_CONTINUE;
	
	static sModel[64];
	static Float:vecSrc[3], Float:vecAngles[3];
	new id = get_msg_arg_int(12);
	
	for (new i; i < 3; i++)
	{
		vecSrc[i] = float(get_msg_arg_int(2 + i)) / 128.0;
		vecAngles[i] = get_msg_arg_float(5 + i);
	}
	
	get_msg_arg_string(1, sModel, charsmax(sModel));
	format(sModel, charsmax(sModel), "models/player/%s/%s.mdl", sModel, sModel);
	
	set_entvar(corpse_id, var_classname, CORPSE_CLASSNAME);
	set_entvar(corpse_id, var_angles, vecAngles);
	set_entvar(corpse_id, var_body, get_msg_arg_int(10));
	set_entvar(corpse_id, var_framerate, 1.0);
	set_entvar(corpse_id, var_animtime, 0.0);
	set_entvar(corpse_id, var_sequence, get_msg_arg_int(9));
	set_entvar(corpse_id, var_team, get_msg_arg_int(11));
	set_entvar(corpse_id, var_owner, id);
	set_entvar(corpse_id, var_model, sModel);
	
	engfunc(EngFunc_SetOrigin, corpse_id, vecSrc);
	engfunc(EngFunc_SetModel, corpse_id, sModel);
	engfunc(EngFunc_SetSize, corpse_id, g_vecMins, g_vecMaxs);
	
	// SetUse(corpse_id, "Corpse_Use");
	SetThink(corpse_id, "Corpse_Think");
	
	g_pCorpse[id] = corpse_id;
	
	// forward RT_StartSneaking(const corpse_id, const owner, const Float:origin[3]);
	ExecuteForward(g_iForward_StartSneaking, g_iForward_Return, corpse_id, id, PrepareArray(_:vecSrc, 3, .copyback = 0));
	switch (g_iForward_Return)
	{
	case CORPSE_CUSTOM:
	{
		
	}
	case CORPSE_DEFAULT:
	{
		UTIL_CorpseRemove(id);
		return PLUGIN_CONTINUE;
	}
	
	case CORPSE_BLOCK:
	{
		UTIL_CorpseRemove(id);
	}
	}
	
	// Hook original corpse
	return PLUGIN_HANDLED;
}

// Удаление трупа
UTIL_CorpseRemove(id)
{
	new corpse_id = g_pCorpse[id];
	
	g_pCorpse[id] = 0;
	
	if (is_nullent(corpse_id))
		return false;
	
	set_entvar(corpse_id, var_nextthink, -1.0);
	set_entvar(corpse_id, var_flags, FL_KILLME);
	
	return true;
}

parse_cfg()
{
	new path[PLATFORM_MAX_PATH];
	get_configsdir(path, charsmax(path));
	strcat(path, "/plugins", charsmax(path));
	
	if (!dir_exists(path) && mkdir(path) == -1)
		return false;
	
	new JSON:jsonMain;
	new JSON:jsonCopy;
	new bool:bCreate;
	
	strcat(path, "/revive_teammates.json", charsmax(path));
	if (file_exists(path))
	{
		jsonMain = json_parse(path, true);
		if (jsonMain == Invalid_JSON)
			return false;
		
		jsonCopy = json_deep_copy(jsonMain);
		bCreate = false;
	}
	else
	{
		jsonMain = json_init_object();
		bCreate = true;
	}
	
	if (!json_object_has_value(jsonMain, RT_SUFFIX, JSONString))
		json_object_set_string(jsonMain, RT_SUFFIX, NULL_STRING);
	
	json_object_set_string(jsonMain, "VERSION", RT_VERSION_STR);
	json_object_set_string(jsonMain, "AUTHOR", "Emma Jule");
	
	if (!json_object_has_value(jsonMain, "INFO", JSONObject))
	{
		new JSON:jsonInfo = json_init_object();
		
		json_object_set_string(jsonInfo, "#", "Значение квара");
		json_object_set_string(jsonInfo, "description", "Описание квара");
		// json_object_set_string(jsonInfo, "default", "Значение по умолчанию");
		json_object_set_string(jsonInfo, "min", "Минимальное допустимое значение");
		json_object_set_string(jsonInfo, "max", "Максимальное допустимое значение");
		
		json_object_set_value(jsonMain, "INFO", jsonInfo);
		json_free(jsonInfo);
	}
	
	// UNDONE: Cvars controller
	json_cvar_string(jsonMain, "chat_prefix", "[Revive Teammates]", "Приставка для чат сообщений^n!y - Желтвый^n!t - Цвет команды^n!g - Зеленый", .cvar = g_sCvarChatPrefix, .len = charsmax(g_sCvarChatPrefix));
	json_cvar_float(jsonMain, "duration", 5.0, "Время действия процесса воскрешения^nИспользуйте 0 для мнгновенного действия (достаточно только нажать кнопку)", .has_min = true, .has_max = true, .max_val = 10.0, .cvar = g_fCvarDuration);
	json_cvar_string(jsonMain, "box_size", "-42.0 -3.44 -22.16 36.0 8.57 24.0", "Минимальный и максимальный размер объекта^nСозданная сущность в игре имеет размеры куба 6 проекций (сверху сбоку сзади спереди слева справо)^nСам труп принимает свойство кнопки (радиус отлова 128 units)", .cvar = g_sCvarSize, .len = charsmax(g_sCvarSize));
	
	replace_color_tag(g_sCvarChatPrefix, charsmax(g_sCvarChatPrefix));
	
	// forward RT_ParseConfigFile(JSON:jsonMain);
	ExecuteForward(g_iForward_ParseCfg, _, jsonMain);
	
	// Check/update config file
	if (bCreate || !json_equals(jsonMain, jsonCopy))
	{
		new szTime[24];
		get_time("%Y.%m.%d - %H:%M:%S", szTime, charsmax(szTime));
		json_object_set_string(jsonMain, RT_SUFFIX, fmt("Config file was changed at %s", szTime));
		json_serial_to_file(jsonMain, path, true);
	}
	
	json_free(jsonMain);
	if (jsonCopy != Invalid_JSON) 
		json_free(jsonCopy);
	
	return true;
}

stock RelationStatus:PlayerRelationship(const player, const target)
{
	if (FreeForAll)
	{
		return GR_NOTTEAMMATE;
	}
	
	// TODO: support GR_NOTTEAMMATE?
	if (!is_user_connected(player) || !is_user_connected(target))
	{
		return GR_NOTTEAMMATE;
	}
	
	// new TeamName:team = get_member(target, m_iTeam);
	if (!VALID_TEAM(target))
	{
		return GR_NOTTEAMMATE;
	}
	
	// Cvar: mp_friendlyfire shouldn't consider us an enemy
	if (get_member(player, m_iTeam) != get_member(target, m_iTeam)
		&& rg_is_player_can_takedamage(player, target))
	{
		return GR_ENEMY;
	}

	return GR_TEAMMATE;
}

public cvar_change_callback(pcvar, const old_value[], const new_value[])
{
	FreeForAll = str_to_num(new_value);
}

/**
 * Retrives a plugin prefix
 *
 * @param string        String buffer to copy 
 * @param len           Max buffer size
 *
 * @noreturn
 */
public Native_RT_GetPrefix(plugin, argc)
{
	set_string(1, g_sCvarChatPrefix, get_param(2));
}

/**
 * Get a entity index of player corpse
 * 
 * @param id            Player index
 * 
 * @return              Entity index of player corpse, 0 otherwise (player alive or switching team, etc..)
 */
public Native_RT_GetCorpse(plugin, argc)
{
	new id = get_param(1);
	
	return g_pCorpse[id];
}

/**
 * Force delete a player corpse
 * 
 * @param id            Player index
 * 
 * @return              true if the deletion was successful, false otherwise
 */
public Native_RT_DeleteCorpse(plugin, argc)
{
	new id = get_param(1);
	
	return UTIL_CorpseRemove(id);
}

/**
 * Checks if the player is using a corpse right now
 * 
 * @param id            Player index
 * 
 * @return              true if using, false otherwise
 */
public bool:Native_RT_IsUsingCorpse(plugin, argc)
{
	new id = get_param(1);
	
	// PFLAG_USE | FCAP_CONTINUE_USE
	return g_bIsActionRightNow[id];
}

/**
 * Force's a begin action of revive
 * 
 * @param corpse_id     Entity index of corpse
 * @param activator     Player index (corpse activator)
 * @param skip_checks   If true, the process cannot be stopped by other plugins
 * 
 * @return              true on success, false otherwise
 */
public Native_RT_GoAction(plugin, argc)
{
	new corpse_id = get_param(1);
	new activator = get_param(2);
	new bool:skip_checks = bool:get_param(3);
	
	new Float:fGameTime = get_gametime();
	new owner = get_entvar(corpse_id, var_owner);
	
	if (g_bIsActionRightNow[activator] || VALID_PLAYER(get_entvar(corpse_id, var_activator)))
	{
		// BreakAction(corpse_id, current_activator, owner, false);
		return false;
	}
	
	// forward RT_StartLoot_Pre(const corpse_id, const activator, const owner);
	ExecuteForward(g_iForward_Loot_Pre, g_iForward_Return, corpse_id, activator, owner);
	if (g_iForward_Return == RT_SUPERCEDE && !skip_checks)
		return false;
	
	set_entvar(corpse_id, var_activator, activator);
	set_entvar(corpse_id, var_timer, fGameTime + g_fCvarDuration);
	set_entvar(corpse_id, var_nextthink, fGameTime);
	
	g_bIsActionRightNow[activator] = true;
	
	// forward RT_StartLoot_Post(const corpse_id, const activator, const owner, Float:duration);
	ExecuteForward(g_iForward_Loot_Post, _, corpse_id, activator, owner, g_fCvarDuration);
	return true;
}

/**
 * Instantly a break action of revive
 * 
 * @param corpse_id     Entity index of corpse
 * @param activator     Player index (corpse activator)
 * @param owner         Player index (owner of corpse)
 * @param complete      Complete status
 * 
 * @return              true on success, false otherwise
 */
public Native_RT_BreakAction(plugin, argc)
{
	new corpse_id = get_param(1);
	new activator = get_param(2);
	new owner = get_param(3);
	new bool:complete = bool:get_param(4);
	
	if (!g_bIsActionRightNow[activator])
		return false;
	
	BreakAction(corpse_id, activator, owner, complete);
	return true;
}

/**
 * Check if an action with this status is possible
 * 
 * @param status        Relation status (see revive_teammates_const.inc)
 * 
 * @return              true on success, false otherwise
 */
public bool:Native_RT_Get_Relation(plugin, argc)
{
	new RelationStatus:status = any:get_param(1);
	
	if (!VALID_RELATION(status))
		return false;
	
	return g_eRelation[status];
}

/**
 * Establish interaction with this status
 * 
 * @param status        Relation status (see revive_teammates_const.inc)
 * @param set           Interaction control
 * 
 * @noreturn
 */
public bool:Native_RT_Set_Relation(plugin, argc)
{
	new RelationStatus:status = any:get_param(1);
	new bool:set = bool:get_param(2);
	
	if (!VALID_RELATION(status))
		return;
	
	g_eRelation[status] = set;
}

/**
 * Get a relationship status between two players
 * 
 * @param player        Player index (like a victim)
 * @param target        Player index (like a attacker)
 * 
 * @return              Relation status (see revive_teammates_const.inc)
 */
public RelationStatus:Native_RT_RelationShipStatus(plugin, argc)
{
	new player = get_param(1);
	new target = get_param(2);
	
	// enum revive_teammates_const.inc
	return PlayerRelationship(player, target);
}