#include <amxmisc>
#include <fakemeta>
#include <reapi>
#include <revive_teammates>

const EntVars:var_sprite = var_iuser1;
#define ptrSprite(%0) (get_entvar(%0, var_sprite))

new const SECTION[] = "life_time";
new const SPRITE_CLASSNAME[] = "corpse_life_time";

new g_sCvarSprite[64],
	Float:g_fCvarSpawnTime,
	Float:g_fCvarDestroyTime,
	Float:g_fCvarScale,
	Float:g_fCvarUpYaw,
	Float:g_fCvarStepTime,
	g_iCvarTeam,
	g_sCvarAccess[16];

new g_iAccess;
new Float:g_vecCorpseOrigin[3];

public plugin_init()
{
	register_plugin("RT: Life Time", RT_VERSION_STR, "Emma Jule");
}

public plugin_cfg()
{
	g_iAccess = read_flags_ex(g_sCvarAccess);
}

public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonLT;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonLT = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonLT = json_init_object();
	}
	
	if (json_is_object(jsonLT))
	{
		json_cvar_string(jsonLT, "sprite", "sprites/revive.spr", "Спрайт (файл) для показа счетчика времени^nМожно оставить пустым, тогда будет просто как таймер!", .cvar = g_sCvarSprite, .len = charsmax(g_sCvarSprite), .precache = true);
		json_cvar_float(jsonLT, "spawn_time", 5.0, "Время, после которого появится таймер отсчета", .cvar = g_fCvarSpawnTime);
		json_cvar_float(jsonLT, "destroy_time", 40.0, "Время жизни трупа^nВнимание: вы должны точно знать сколько фреймов в вашем спрайте!", .cvar = g_fCvarDestroyTime);
		json_cvar_float(jsonLT, "scale", 0.15, "Размер спрайта", .cvar = g_fCvarScale);
		json_cvar_float(jsonLT, "up_yaw", 24.0, "На сколько юнит поднять спрайт над трупом", .cvar = g_fCvarUpYaw);
		json_cvar_float(jsonLT, "step_time", 1.0, "Интервал времени отсчета (тоесть это может быть не обязательно секунда)", .cvar = g_fCvarStepTime);
		json_cvar_integer(jsonLT, "team", 0, "Действие команд^n0 - Работает для всех^n1 - Работает только для TERRORIST^n2 - Работает только для CT", .has_min = true, .has_max = true, .max_val = 2, .cvar = g_iCvarTeam);
		json_cvar_string(jsonLT, "flag", NULL_STRING, "Флаг(и) доступа к исключению!^n0 или '' - Плагин действует для всех!", .cvar = g_sCvarAccess, .len = charsmax(g_sCvarAccess));
		
		json_object_set_value(jsonMain, SECTION, jsonLT);
		json_free(jsonLT);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public RT_StartSneaking(const corpse_id, const owner, const Float:origin[3])
{
	// Not allowed team
	if (g_iCvarTeam > 0 && get_entvar(corpse_id, var_team) != g_iCvarTeam)
		return;
	
	// Special users ignored
	if (get_user_flags(owner) & g_iAccess)
		return;
	
	new pSprite = rg_create_entity("info_target");
	
	set_entvar(pSprite, var_classname, SPRITE_CLASSNAME);
	set_entvar(pSprite, var_scale, g_fCvarScale);
	set_entvar(pSprite, var_effects, EF_NODRAW);
	set_entvar(pSprite, var_nextthink, get_gametime() + g_fCvarSpawnTime);
	set_entvar(pSprite, var_sprite, corpse_id);
	
	g_vecCorpseOrigin = origin;
	g_vecCorpseOrigin[2] += g_fCvarUpYaw;
	engfunc(EngFunc_SetOrigin, pSprite, g_vecCorpseOrigin);
	if (g_sCvarSprite[0])
		engfunc(EngFunc_SetModel, pSprite, g_sCvarSprite);
	
	SetThink(pSprite, "@ThinkSprite");
	set_entvar(corpse_id, var_sprite, pSprite);
}

public RT_StopSneaking(const corpse_id, const owner)
{
	new pSprite = ptrSprite(corpse_id);
	if (is_nullent(pSprite))
		return;
	
	set_entvar(pSprite, var_nextthink, -1.0);
	engfunc(EngFunc_RemoveEntity, pSprite);
}

@ThinkSprite(const pSprite)
{
	new Float:frames = Float:get_entvar(pSprite, var_frame);
	if (frames == 0.0)
	{
		set_entvar(pSprite, var_frame, g_fCvarDestroyTime - 1.0);
		set_entvar(pSprite, var_effects, 0);
	}
	else
	{
		if (--frames > 0.0)
		{
			set_entvar(pSprite, var_frame, frames);
		}
		else
		{
			new corpse_id = ptrSprite(pSprite);
			RT_DeleteCorpse(get_entvar(corpse_id, var_owner));
			return;
		}
	}
	
	set_entvar(pSprite, var_nextthink, get_gametime() + g_fCvarStepTime);
}