#include <amxmodx>
#include <reapi>
#include <hamsandwich>
#include <revive_teammates>

stock const EntVars:var_miner = var_euser2;
#define ptrMiner(%0) (get_entvar(%0, var_miner))

new const SECTION[] = "mined_enemies";

new g_sCvarPrefix[48],
	g_sCvarAccess[16],
	g_iCvarMaxUse,
	g_iCvarMode,
	g_iCvarBar,
	Float:g_fCvarRadius,
	Float:g_fCvarDamage,
	Float:g_fCvarPainshock,
	g_iCvarRadiusDamage,
	g_iCvarScreenPunch,
#if REAPI_VERSION >= 5200231
	g_iCvarGibs,
#endif
	g_iCvarExplodeEffects,
	g_sCvarMinedSucessfully[64],
	g_sCvarMinedExplode[64],
	g_sCvarAlert[4];

enum (<<=1) {
	ALERT_CHAT = 1,
	ALERT_CENTER,
	ALERT_HUD
};

new g_iMinesCount[33];
new g_iAccess;
new g_Alert;
new g_sModelIndexFireball, g_sModelIndexFireball2, g_sModelIndexFireball3;
new g_cSoundExplosionDisabled;

public plugin_precache()
{
	g_sModelIndexFireball = precache_model("sprites/zerogxplode.spr");
	g_sModelIndexFireball2 = precache_model("sprites/eexplo.spr");
	g_sModelIndexFireball3 = precache_model("sprites/fexplo.spr");
}

public plugin_init()
{
	register_plugin("RT: Mined Enemies Mode", RT_VERSION_STR, "Emma Jule");
	
	RegisterHookChain(RG_CBasePlayer_UseEmpty, "CBasePlayer_UseEmpty", true);
	RegisterHookChain(RG_CSGameRules_RestartRound, "CSGameRules_RestartRound", true);
}

public plugin_cfg()
{
	g_iAccess = read_flags_ex(g_sCvarAccess);
	g_Alert = read_flags_ex(g_sCvarAlert);
	g_cSoundExplosionDisabled = equal(g_sCvarMinedExplode, "off");
	
	RT_GetPrefix(g_sCvarPrefix, charsmax(g_sCvarPrefix));
	RT_Set_Relation(GR_ENEMY, true);
}

public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonME;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonME = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonME = json_init_object();
	}
	
	if (json_is_object(jsonME))
	{
		json_cvar_string(jsonME, "flag", "", "Флаг(и) доступа к минированию врагов!^n0 или '' - Для всех", .cvar = g_sCvarAccess, .len = charsmax(g_sCvarAccess));
		json_cvar_integer(jsonME, "max_usage", 2, "Сколько максимально сможет минировать трупов игрок за раунд", .cvar = g_iCvarMaxUse);
		json_cvar_integer(jsonME, "mined_mode", 0, "Режим активации взрыва:^n0 - После процесса воскрешения^n1 - Моментально (сразу после активации трупа)^n2 - Детонация (все заминированные трупы взорвутся, после того как игрок нажал дважды E)", .cvar = g_iCvarMode);
		json_cvar_integer(jsonME, "bar", 1, "Полоска прогресса минирования", .cvar = g_iCvarBar);
		json_cvar_float(jsonME, "radius", 250.0, "Максимальный допустимый радиус поражения", .has_min = true, .min_val = 64.0, .has_max = true, .max_val = 500.0, .cvar = g_fCvarRadius);
		json_cvar_float(jsonME, "damage", 50.0, "Урон от взрыва", .has_min = true, .min_val = 10.0, .cvar = g_fCvarDamage);
		json_cvar_float(jsonME, "painshock", 0.01, "Болевой шок после удара (сила замедления диапазон: от 0 до 1)", .has_min = true, .min_val = 0.01, .has_max = true, .max_val = 1.0, .cvar = g_fCvarPainshock);
		json_cvar_integer(jsonME, "damage_include_radius", 0, "Урон будет зависить от радиуса, чем дальше игрок тем меньше урона он получит^nКонтролируйте также урон, т.к. при радиусе игрок мало что получит", .cvar = g_iCvarRadiusDamage);
		json_cvar_integer(jsonME, "screen_punch", 1, "Тряска экрана от полученного урона (взрывной волны)", .cvar = g_iCvarScreenPunch);
#if REAPI_VERSION >= 5200231
		json_cvar_integer(jsonME, "gibs", 1, "Создаются ошметки после взрыва заминированного трупа", .cvar = g_iCvarGibs);
#endif
		json_cvar_integer(jsonME, "explode_sprites", 1, "Эффект взврывчатки при детонации заминированного трупа", .cvar = g_iCvarExplodeEffects);
		json_cvar_string(jsonME, "mined_sound", NULL_STRING, "Звук при успешном минировании трупа!", .cvar = g_sCvarMinedSucessfully, .len = charsmax(g_sCvarMinedSucessfully), .precache = true);
		json_cvar_string(jsonME, "explode_sound", NULL_STRING, "Звук взрыва трупа!^nПри пустом значении будет использоваться стандартный звук спрайта.^nИспользуйте 'off' - если хотите полностью исключить звук!", .cvar = g_sCvarMinedExplode, .len = charsmax(g_sCvarMinedExplode), .precache = true);
		json_cvar_string(jsonME, "alert_mode", "c", "Режим уведомлений^na - в чат^nb - по центру экрана^nc - HUD (плавное сообщение)^nПримечание: можно использовать посовместно (abc)^n'' или 0 - Отключено", .cvar = g_sCvarAlert, .len = charsmax(g_sCvarAlert));
		
		json_object_set_value(jsonMain, SECTION, jsonME);
		json_free(jsonME);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public CSGameRules_RestartRound()
{
	arrayset(g_iMinesCount, 0, 33);
}

public CBasePlayer_UseEmpty(const id)
{
	if (g_iCvarMode != 2)
		return;
	
	static Float:fNextUseTime[33];
	new Float:fGameTime = get_gametime();
	
	if (fNextUseTime[id] > fGameTime)
	{
		fNextUseTime[id] = 0.0;
		
		new corpse_id = rg_find_ent_by_class(NULLENT, CORPSE_CLASSNAME);
		while (corpse_id > 0)
		{
			if (ptrMiner(corpse_id) != id)
			{
				
			}
			else
			{
				ExplodeCorpse(corpse_id);
			}
			
			corpse_id = rg_find_ent_by_class(corpse_id, CORPSE_CLASSNAME);
		}
	}
	else
	{
		fNextUseTime[id] = fGameTime + 0.2;
	}
}

public RT_StartLoot_Pre(const corpse_id, const activator, const owner)
{
	if (RT_RelationShipStatus(owner, activator) != GR_ENEMY)
		return RT_CONTINUE;
	
	// Restrictions
	if ((get_user_flags(activator) & g_iAccess) != g_iAccess)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_MINED_NO_ACCESS");
		return RT_SUPERCEDE;
	}
	
	if (g_iMinesCount[activator] >= g_iCvarMaxUse)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_MINED_MAX_USAGE", g_iCvarMaxUse);
		return RT_SUPERCEDE;
	}
	
	// Fixes
	new pMiner = ptrMiner(corpse_id);
	if (is_user_connected(pMiner) && RT_RelationShipStatus(activator, pMiner) == GR_TEAMMATE)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_MINED_ALREADY", pMiner);
		return RT_SUPERCEDE;
	}
	
	return RT_CONTINUE;
}

public RT_StartLoot_Post(const corpse_id, const activator, const owner, Float:duration)
{
	new RelationStatus:status = RT_RelationShipStatus(owner, activator);
	
	if (g_iCvarMode == 1 && status == GR_TEAMMATE && VALID_PLAYER(ptrMiner(corpse_id)))
	{
		ExplodeCorpse(corpse_id);
		return;
	}
	
	if (status != GR_ENEMY)
		return;
	
	if (g_iCvarBar)
	{
		rg_send_bartime(activator, floatround(duration));
	}
	
	if (g_Alert & ALERT_CHAT)
	{
		client_print_color(activator, owner, "%s %l", g_sCvarPrefix, "RT_MINING_PRINT_CHAT", owner, duration);
	}
	
	if (g_Alert & ALERT_CENTER)
	{
		client_print(activator, print_center, "%l", "RT_MINING_PRINT_CENTER", owner, duration);
	}
	
	if (g_Alert & ALERT_HUD)
	{
		set_dhudmessage(160, 0, 30, -1.0, 0.76, 2, 3.0, 2.0, 0.03, 0.4);
		show_dhudmessage(activator, "%L", LANG_PLAYER, "RT_MINING_HUD", owner, duration);
	}
}

public RT_StopLoot(const corpse_id, const activator, const owner, bool:complete)
{
	new RelationStatus:status = RT_RelationShipStatus(owner, activator);
	
	if (complete)
	{
		// Still explode
		if (status == GR_TEAMMATE && VALID_PLAYER(ptrMiner(corpse_id)))
		{
			ExplodeCorpse(corpse_id);
			return RT_SUPERCEDE;
		}
		// Enemy mined
		else if (status == GR_ENEMY)
		{
			g_iMinesCount[activator]++;
			set_entvar(corpse_id, var_miner, activator);
			client_print_color(activator, owner, "%s %l", g_sCvarPrefix, "RT_MINING_SUCESSFULLY", owner);
			
			if (g_sCvarMinedSucessfully[0])
			{
				rh_emit_sound2(corpse_id, 0, CHAN_BODY, g_sCvarMinedSucessfully);
			}
			
			return RT_SUPERCEDE;
		}
	}
	else if (status == GR_ENEMY && g_iCvarBar)
	{
		rg_send_bartime(activator, 0);
	}
	
	return RT_CONTINUE;
}

ExplodeCorpse(const corpse_id)
{
	static Float:vecSrc[3];
	get_entvar(corpse_id, var_origin, vecSrc);
	
	new miner = ptrMiner(corpse_id);
	if (!is_user_connected(miner))
		miner = 0;
	
#if REAPI_VERSION >= 5200231
	if (g_iCvarGibs)
	{
		// set_entvar(corpse_id, var_velocity, Float:{275.0, 1050.0, 150.0});
		// set_entvar(corpse_id, var_health, random_float(-250.0, 0.0));
		rg_spawn_random_gibs(corpse_id, random_num(3, 6), true);
	}
#endif
	
	if (g_iCvarExplodeEffects)
	{
		UTIL_MakeExplosionEffects(vecSrc);
	}
	
	if (!g_cSoundExplosionDisabled && g_sCvarMinedExplode[0])
	{
		rh_emit_sound2(corpse_id, 0, CHAN_BODY, g_sCvarMinedExplode);
	}
	
	new TeamName:corpseTeam = get_entvar(corpse_id, var_team);
	new Float:damageDealt = g_fCvarDamage;
	new Float:vecEnd[3];
	
	for (new i = MaxClients; i > 0; --i)
	{
		if (!is_user_alive(i))
			continue;
		
		// RT_RelationShipStatus ?
		if (get_member(i, m_iTeam) != corpseTeam)
			continue;
		
		get_entvar(i, var_origin, vecEnd);
		
		if (g_iCvarRadiusDamage)
		{
			damageDealt = (damageDealt - vector_distance(vecSrc, vecEnd) * (g_fCvarDamage / g_fCvarRadius));
			
			if (damageDealt < 1.0)
				continue;
		}
		else if (vector_distance(vecSrc, vecEnd) > g_fCvarRadius)
			continue;
		
		set_member(i, m_LastHitGroup, HITGROUP_GENERIC);
		if (ExecuteHamB(Ham_TakeDamage, i, corpse_id, miner, damageDealt, DMG_GRENADE))
		{
			set_member(i, m_flVelocityModifier, g_fCvarPainshock);
			
			if (g_iCvarScreenPunch)
				set_entvar(i, var_punchangle, Float:{42.2, 19.0, 64.4});
		}
	}
	
	// rh_emit_sound2(corpse_id, 0, CHAN_WEAPON, "turret/tu_deploy.wav", 0.0, ATTN_NONE, SND_STOP);
	RT_DeleteCorpse(get_entvar(corpse_id, var_owner));
	
	return RT_CONTINUE;
}

stock UTIL_MakeExplosionEffects(const Float:vecSrc[3])
{
	new flags = TE_EXPLFLAG_NONE;
	if (g_cSoundExplosionDisabled || g_sCvarMinedExplode[0])
		flags |= TE_EXPLFLAG_NOSOUND;
	
	message_begin_f(MSG_PAS, SVC_TEMPENTITY, vecSrc);
	write_byte(TE_EXPLOSION); // This makes a dynamic light and the explosion sprites/sound
	write_coord_f(vecSrc[0]); // Send to PAS because of the sound
	write_coord_f(vecSrc[1]);
	write_coord_f(vecSrc[2] + 20.0);
	write_short(g_sModelIndexFireball3);
	write_byte(25); // scale * 10
	write_byte(30); // framerate
	write_byte(flags); // flags
	message_end();

	message_begin_f(MSG_PAS, SVC_TEMPENTITY, vecSrc);
	write_byte(TE_EXPLOSION); // This makes a dynamic light and the explosion sprites/sound
	write_coord_f(vecSrc[0] + random_float(-64.0, 64.0)); // Send to PAS because of the sound
	write_coord_f(vecSrc[1] + random_float(-64.0, 64.0));
	write_coord_f(vecSrc[2] + random_float(30.0, 35.0));
	write_short(g_sModelIndexFireball2);
	write_byte(30); // scale * 10
	write_byte(30); // framerate
	write_byte(flags); // flags
	message_end();

	message_begin_f(MSG_PAS, SVC_TEMPENTITY, vecSrc);
	write_byte(TE_SPRITE);
	write_coord_f(vecSrc[0] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[1] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[2] + random_float(-10.0, 10.0));
	write_short(g_sModelIndexFireball2);
	write_byte(30);
	write_byte(150);
	message_end();
	
	message_begin_f(MSG_PAS, SVC_TEMPENTITY, vecSrc);
	write_byte(TE_SPRITE);
	write_coord_f(vecSrc[0] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[1] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[2] + random_float(-10.0, 10.0));
	write_short(g_sModelIndexFireball2);
	write_byte(30);
	write_byte(150);
	message_end();

	message_begin_f(MSG_PAS, SVC_TEMPENTITY, vecSrc);
	write_byte(TE_SPRITE);
	write_coord_f(vecSrc[0] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[1] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[2] + random_float(-10.0, 10.0));
	write_short(g_sModelIndexFireball3);
	write_byte(30);
	write_byte(150);
	message_end();

	message_begin_f(MSG_PAS, SVC_TEMPENTITY, vecSrc);
	write_byte(TE_SPRITE);
	write_coord_f(vecSrc[0] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[1] + random_float(-256.0, 256.0));
	write_coord_f(vecSrc[2] + random_float(-10.0, 10.0));
	write_short(g_sModelIndexFireball);
	write_byte(30);
	write_byte(17);
	message_end();
}