#include <amxmisc>
#include <reapi>
#include <revive_teammates>

new const SECTION[] = "misc";

new Float:g_fNextCorpseUsingTime[33];
new Float:g_fCvarNextUseTime,
	g_iCvarCatchMode;

public plugin_init()
{
	register_plugin("RT: Misc", RT_VERSION_STR, "Emma Jule");
	
	RegisterHookChain(RG_CBasePlayer_UseEmpty, "CBasePlayer_UseEmpty", true);
}

// API Features example
public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonMisc;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonMisc = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonMisc = json_init_object();
	}
	
	if (json_is_object(jsonMisc))
	{
		json_cvar_float(jsonMisc, "next_use", 0.7, "Время после которого игрок вновь сможет использовать трупы (+use)", .has_min = true, .min_val = 0.1, .has_max = true, .max_val = 5.0, .cvar = g_fCvarNextUseTime);
		json_cvar_integer(jsonMisc, "catch_mode", 1, "Метод поиска трупа^n0 - Отлов первого попавшегося трупа в радиусе^n1 - Отлов трупа с максимально близкой дистанцией к игроку", .cvar = g_iCvarCatchMode);
		
		json_object_set_value(jsonMain, SECTION, jsonMisc);
		json_free(jsonMisc);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public plugin_cfg()
{
	// There are no restrictions between teammates, by default
	RT_Set_Relation(GR_TEAMMATE, true);
}

public CBasePlayer_UseEmpty(const id)
{
	new Float:fGameTime = get_gametime();
	
	if (g_fNextCorpseUsingTime[id] > fGameTime) {
		return;
	}
	else {
		g_fNextCorpseUsingTime[id] = fGameTime + g_fCvarNextUseTime;
	}
	
	if (RT_IsUsing(id)) {
		return;
	}
	
	new aPlayers[MAX_PLAYERS], iCount;
	get_players_ex(aPlayers, iCount, GetPlayers_ExcludeAlive | GetPlayers_ExcludeHLTV);
	if (!iCount) {
		return;
	}
	
	new corpse;
	new corpse_id;
	new Float:dist, Float:best_dist;
	
	while (--iCount >= 0)
	{
		corpse_id = RT_GetCorpse(aPlayers[iCount]);
		if (!corpse_id) {
			continue;
		}
		
		// Not loaded
		if (!RT_Get_Relation(RT_RelationShipStatus(aPlayers[iCount], id))) {
			continue;
		}
		
		dist = rg_entity_range(id, corpse_id);
		if (dist > CORPSE_MAX_RANGE) {
			continue;
		}
		
		if (!best_dist || dist < best_dist) {
			best_dist = dist;
			corpse = corpse_id;
			
			if (!g_iCvarCatchMode) {
				break;
			}
		}
	}
	
	if (corpse > 0) {
		RT_GoAction(corpse, id);
	}
}

public RT_StartLoot_Pre(const corpse_id, const activator, const owner)
{
	new RelationStatus:status = RT_RelationShipStatus(owner, activator);
	if (!RT_Get_Relation(status))
	{
		// return RT_SUPERCEDE;
	}
	
	return RT_CONTINUE;
}

public RT_ThinkLoot(const corpse_id, const activator, const owner, Float:time_ending, &nextthink)
{
	if (rg_entity_range(activator, corpse_id) > CORPSE_MAX_RANGE)
	{
		return RT_SUPERCEDE;
	}
	
	return RT_CONTINUE;
}
