#include <amxmodx>
#include <reapi>
#include <xs>
#include <revive_teammates>

new const SECTION[] = "model_support";

new g_iCvarSkin,
	g_iCvarMinModels,
	g_iCvarSizeFromMdl;

new g_iSkin[33];

public plugin_init()
{
	register_plugin("RT: Models support", RT_VERSION_STR, "Emma Jule");
	
	RegisterHookChain(RG_CBasePlayer_Killed, "CBasePlayer_Killed", true);
}

public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonSupport;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonSupport = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonSupport = json_init_object();
	}
	
	if (json_is_object(jsonSupport))
	{
		json_cvar_integer(jsonSupport, "skin_support", 0, "Поддержка субмоделей^nАктивируйте если вы используете skin в моделях игроков", .cvar = g_iCvarSkin);
		json_cvar_integer(jsonSupport, "cl_minmodels_support", 0, "Поддержка клиентов с активным кваром cl_minmodels 1", .cvar = g_iCvarMinModels);
		json_cvar_integer(jsonSupport, "size_from_file", 0, "Будет брать размеры объекта напрямую с файла модели.", .cvar = g_iCvarSizeFromMdl);
		
		json_object_set_value(jsonMain, SECTION, jsonSupport);
		json_free(jsonSupport);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public RT_StartSneaking(const corpse_id, const owner, const Float:origin[3])
{
	if (g_iCvarMinModels)
	{
		set_entvar(corpse_id, var_frame, get_entvar(owner, var_frame));
		set_entvar(corpse_id, var_renderfx, kRenderFxDeadPlayer); /* kRenderAmt is the player index */
		set_entvar(corpse_id, var_renderamt, float(owner));
	}
	
	if (g_iCvarSkin)
	{
		// Fix: pev->skin 0.
		set_entvar(corpse_id, var_skin, g_iSkin[owner]);
	}
	
	if (g_iCvarSizeFromMdl)
	{
		static sModel[64];
		static Float:vSize[3];
		
		get_entvar(corpse_id, var_model, sModel, charsmax(sModel));
		UTIL_Modelsize(sModel, vSize);
		// xs_vec_sub(vMaxs, vMins, vMaxs);
		set_entvar(corpse_id, var_size, vSize);
		
		// server_print("%s %f %f %f %f %f %f", sModel, vSize[0], vSize[1], vSize[2]);
	}
	
	return CORPSE_CUSTOM;
}

public CBasePlayer_Killed(const id)
{
	g_iSkin[id] = get_entvar(id, var_skin);
}

stock UTIL_Modelsize(const file[], Float:size[3])
{
	new f = fopen(file, "rb");
	if (!f)
		return;
	
	new bboff, Float:vec[6];
	
	// fseek(f, 176, SEEK_SET);
	fseek(f, 160, SEEK_SET);
	fread(f, bboff, BLOCK_INT);
	fseek(f, bboff + 8, SEEK_SET);
	fread_blocks(f, _:vec, 6, BLOCK_INT);
	fclose(f);
	
	// vecSize = vecMaxs - vecMins
	
/*
	for (new i; i < 3; i++)
	{
		vMins[i] = vec[i];
		vMaxs[i] = vec[i + 3];
	}
*/
	
	for (new i; i < 3; i++) {
		size[i] = vec[i + 3] - vec[i];
	}
}