#include <amxmodx>
#include <fakemeta>
#include <reapi>
#include <xs>
#include <revive_teammates>

new const SECTION[] = "respawn_features";

new g_iCvarSpawnPlace,
	Float:g_fCvarUnstuck;

new Float:_origin[33][3];

public plugin_init()
{
	register_plugin("RT: Respawn Features", RT_VERSION_STR, "Emma Jule");
}

public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonRF;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonRF = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonRF = json_init_object();
	}
	
	if (json_is_object(jsonRF))
	{
		json_cvar_float(jsonRF, "unstuck", 1.75, "Поле увеличивающего прогресса для поиска свободной точки", .cvar = g_fCvarUnstuck);
		json_cvar_integer(jsonRF, "spawn_place", 1, "Место спавна воскрешенного игрока^n0 - На респе^n1 - В игроке, который воскресил тело (используйте вместе с semiclip)^n2 - На том месте где был заспавнен труп", .cvar = g_iCvarSpawnPlace);
		
		json_object_set_value(jsonMain, SECTION, jsonRF);
		json_free(jsonRF);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public RT_StartSneaking(const corpse_id, const owner, const Float:origin[3])
{
	_origin[owner] = origin;
	_origin[owner][2] += 18.0;
}

public RT_GotRespawn(const id, const friend)
{
	if (g_iCvarSpawnPlace)
	{
		new Float:vecEnd[3];
		new skip;
		
		if (g_iCvarSpawnPlace == 1)
		{
			get_entvar(friend, var_origin, vecEnd);
			skip = IGNORE_MONSTERS;
		}
		else
		{
			vecEnd = _origin[id];
		}
		
		if (g_fCvarUnstuck > 0.0)
		{
			new Float:vecMins[3];
			new Float:step = g_fCvarUnstuck;
			new Float:roll, Float:pitch;
			new nextStage;
			
			get_entvar(id, var_mins, vecMins);
			
			do
			{
				switch (nextStage++)
				{
				case 0:
				{
					roll = step;
					pitch = step;
				}
				case 1:
				{
					roll = step;
					pitch = -step;
				}
				case 2:
				{
					roll = -step;
					pitch = -step;
				}
				case 3:
				{
					roll = -step;
					pitch = step;
					nextStage = 0;
					step += g_fCvarUnstuck;
				}
				}
				
				vecEnd[0] = (vecEnd[0] - vecMins[0] * roll);
				vecEnd[1] = (vecEnd[1] - vecMins[1] * pitch);
				
				if (UTIL_IsFreePlace(vecEnd, skip))
				{
					break;
				}
			}
			// You may controlle it
			while (step < 36.0);
		}
		
		set_entvar(id, var_flags, get_entvar(id, var_flags) | FL_DUCKING);
		set_entvar(id, var_view_ofs, Float:{0.0, 0.0, 12.0});
		set_entvar(id, var_velocity, NULL_VECTOR);
		
		engfunc(EngFunc_SetOrigin, id, vecEnd);
	}
}

// checks if a space is vacant, by VEN
stock bool:UTIL_IsFreePlace(Float:origin[3], const skip)
{
	engfunc(EngFunc_TraceHull, origin, origin, skip, HULL_HEAD, 0, 0);

	return bool:(!get_tr2(0, TR_StartSolid) && !get_tr2(0, TR_AllSolid) && get_tr2(0, TR_InOpen));
}
