#include <amxmodx>
#include <reapi>
#include <hamsandwich>
#include <revive_teammates>

#if !defined PLAYER_PREVENT_JUMP
#define PLAYER_PREVENT_JUMP             (1<<6)
#endif

new const SECTION[] = "restrictions";

new g_sCvarPrefix[48],
	g_sCvarAccess[16],
	g_iCvarMaxSpawns,
	g_iCvarMaxUsage,
	g_iCvarHookAttack,
	g_iCvarRound,
	g_iCvarRoundTerminating,
	g_iCvarCost,
	g_iCvarBomb,
	g_iCvarWaterlevel,
	g_iCvarOnLadder,
	g_iCvarVIP,
	g_iCvarPlayerDuel,
	g_iCvarPlayerDifference,
	g_iCvarDomination,
	Float:g_fCvarTimeExpired,
	Float:g_fCvarTimeRemaining,
	g_iCvarCanJump,
	g_iCvarCanDuck,
	Float:g_fCvarMaxSpeed,
	g_iCvarHoldUse,
	g_iCvarViewCone;

new g_playerRevivals[33];
// new Float:g_fOldGravity[33];
new g_iAccess;
new g_pBomb;

public plugin_init()
{
	register_plugin("RT: Restrictions", RT_VERSION_STR, "Emma Jule");
	
	// RegisterHookChain(RG_CBasePlayer_Spawn, "CBasePlayer_Spawn", true);
	RegisterHookChain(RG_CBasePlayer_ResetMaxSpeed, "CBasePlayer_ResetMaxSpeed", true);
	RegisterHookChain(RG_CSGameRules_RestartRound, "CSGameRules_RestartRound", false);
	RegisterHookChain(RG_PlantBomb, "CGrenade_PlantBomb", true);
}

public plugin_cfg()
{
	g_iAccess = read_flags_ex(g_sCvarAccess);
	
	RT_GetPrefix(g_sCvarPrefix, charsmax(g_sCvarPrefix));
}

public RT_ParseConfigFile(JSON:jsonMain)
{
	new JSON:jsonRestrictions;
	
	if (json_object_has_value(jsonMain, SECTION, JSONObject))
	{
		jsonRestrictions = json_object_get_value(jsonMain, SECTION);
	}
	else
	{
		jsonRestrictions = json_init_object();
	}
	
	if (json_is_object(jsonRestrictions))
	{
		json_cvar_string(jsonRestrictions, "flag", "", "Флаг(и) доступа к возрождению тиммейтов!^n0 или '' - Для всех", g_sCvarAccess, charsmax(g_sCvarAccess));
		json_cvar_integer(jsonRestrictions, "max_spawns", 3, "Если игрок возрождался более чем Х раз в этом раунде^nто его нельзя будет возродить этим плагином!", .cvar = g_iCvarMaxSpawns);
		json_cvar_integer(jsonRestrictions, "max_usage", 2, "Сколько максимально может поднять тиммейтов игрок за раунд", .cvar = g_iCvarMaxUsage);
		json_cvar_integer(jsonRestrictions, "block_attack", 1, "Игрок не сможет стрелять в момент действия с трупом", .cvar = g_iCvarHookAttack);
		json_cvar_integer(jsonRestrictions, "round", 0, "Использовать труп можно только со Х раунда! (будет спавнить обычные трупы)", .cvar = g_iCvarRound);
		json_cvar_integer(jsonRestrictions, "round_ended", 0, "Невозможно использовать труп в конце раунда!", .cvar = g_iCvarRoundTerminating);
		json_cvar_integer(jsonRestrictions, "cost", 0, "Плата за использования трупа [$]", .cvar = g_iCvarCost);
		json_cvar_integer(jsonRestrictions, "bomb", 0, "Нельзя использовать труп когда бомба уже установленна", .cvar = g_iCvarBomb);
		json_cvar_integer(jsonRestrictions, "waterlevel", 0, "Нельзя использовать если уровень воды игрока^n0 - Любой^n1 - Ноги в воде^n2 - По пояс в воде^n3 - Полностью в воде", .cvar = g_iCvarWaterlevel);
		json_cvar_integer(jsonRestrictions, "on_ladder", 0, "Игрок не сможет использовать труп когда находится на лестнице", .cvar = g_iCvarOnLadder);
		json_cvar_integer(jsonRestrictions, "vip_person", 0, "VIP-персона не может использовать трупы^nЭто работает на сценарии 'Спасти VIP' [as_* карты]", .cvar = g_iCvarVIP);
		json_cvar_integer(jsonRestrictions, "players_duel", 0, "Никто не может использовать трупы когда остались 1 на 1", .cvar = g_iCvarPlayerDuel);
		json_cvar_integer(jsonRestrictions, "players_difference", 0, "Нельзя использовать трупы если разница живых игроков превышет этот квар^nПримечание: это не коснется команды которая в меньшинстве!^n0 - Выключает эту возможность", .cvar = g_iCvarPlayerDifference);
		json_cvar_integer(jsonRestrictions, "domination", 0, "Доминирующая команда не может использовать трупы!^nЭто касается команды которая одерживает Х побед подряд!", .cvar = g_iCvarDomination);
		json_cvar_float(jsonRestrictions, "time_expired", 0.0, "Использование трупа работает если от начала раунда прошло более Х сек.", .has_max = true, .max_val = 60.0, .cvar = g_fCvarTimeExpired);
		json_cvar_float(jsonRestrictions, "time_remaining", 0.0, "Нельзя использовать труп за Х сек. до конца раунда", .has_max = true, .max_val = 120.0, .cvar = g_fCvarTimeRemaining);
		json_cvar_integer(jsonRestrictions, "can_jump", 1, "Игрок может прыгать в момент использования трупа", .cvar = g_iCvarCanJump);
		json_cvar_integer(jsonRestrictions, "can_duck", 1, "Игрок может сидеть/присаживатся в момент использования трупа", .cvar = g_iCvarCanDuck);
		json_cvar_float(jsonRestrictions, "maxspeed", 1.0, "Скорость игрока в момент использования трупа^n1 - Стоит на месте", .has_min = true, .cvar = g_fCvarMaxSpeed);
		json_cvar_integer(jsonRestrictions, "hold_use", 1, "Игрок должен удерживать E (+use) чтобы использовать труп^n0 - Достаточно просто нажать!", .cvar = g_iCvarHoldUse);
		json_cvar_integer(jsonRestrictions, "view_cone", 0, "Игрок может взаимодействовать с трупом только если он в зоне видимости его экрана", .cvar = g_iCvarViewCone);
		
		json_object_set_value(jsonMain, SECTION, jsonRestrictions);
		json_free(jsonRestrictions);
	}
	else
		set_fail_state("Module <%s> loading failed. Check config settings!", SECTION);
}

public CBasePlayer_Spawn(const id)
{
	if (rg_is_user_first_spawn(id))
	{
		g_playerRevivals[id] = 0;
	}
}

public CBasePlayer_ResetMaxSpeed(const id)
{
	if (g_fCvarMaxSpeed > 0.0 && RT_IsUsing(id))
	{
		set_entvar(id, var_maxspeed, g_fCvarMaxSpeed);
	}
}

public CSGameRules_RestartRound()
{
	g_pBomb = 0;
	arrayset(g_playerRevivals, 0, 33);
}

public CGrenade_PlantBomb(const id, Float:vecStart[3], Float:vecVelocity[3])
{
	// Это в основном для квара time_remaining (используется также для проверки установленной бомбы)
	// Дело в том что m_fRoundStartTimeReal не обновляются когда бомба заложена
	// Поэтому rg_get_remaining_time() вернет неправильные данные или вообще отрицательные
	// Так как время до конца раунда остается прежним используется m_Grenade_flC4Blow для проверки конца бомбы
	g_pBomb = GetHookChainReturn(ATYPE_INTEGER);
}

public RT_StartSneaking(const corpse_id, const owner, const Float:origin[3])
{
	if (rg_get_current_round() < g_iCvarRound)
	{
		return CORPSE_DEFAULT;
	}
	
	return CORPSE_CUSTOM;
}

public RT_StartLoot_Pre(const corpse_id, const activator, const owner)
{
	// Эти квары должны касатся только тиммейтов
	// Стоит ли делать GR_NOTTEAMMATE ?
	if (RT_RelationShipStatus(owner, activator) == GR_TEAMMATE)
	{
		if ((get_user_flags(activator) & g_iAccess) != g_iAccess)
		{
			client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_NO_ACCESS");
			return RT_SUPERCEDE;
		}
		
		if (g_playerRevivals[activator] >= g_iCvarMaxUsage)
		{
			client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_MAX_USAGE", g_iCvarMaxUsage);
			return RT_SUPERCEDE;
		}
		
		if (get_member(owner, m_iNumSpawns) > g_iCvarMaxSpawns)
		{
			client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_MAX_SPAWNS", g_iCvarMaxSpawns);
			return RT_SUPERCEDE;
		}
	}
	
	if (g_iCvarVIP && get_member(activator, m_bIsVIP))
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_VIP_PERSON");
		return RT_SUPERCEDE;
	}
	
	if (g_iCvarDomination > 0 && rg_get_team_wins_row(g_iCvarDomination) == get_member(activator, m_iTeam))
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_DOMINATION", g_iCvarDomination);
		return RT_SUPERCEDE;
	}
	
	// Also use in RT_ThinkLoot
	if (UTIL_IsRestricted(corpse_id, activator))
	{
		return RT_SUPERCEDE;
	}
	
	return RT_CONTINUE;
}

public RT_StartLoot_Post(const corpse_id, const activator, const owner, Float:duration)
{
	if (g_iCvarHookAttack)
	{
		rg_toggle_flashlight(activator, false);
		set_member(activator, m_bIsDefusing, true);
	}
	
	new flags;
	if (!g_iCvarCanJump)
	{
		flags |= PLAYER_PREVENT_JUMP;
	}
	
	if (!g_iCvarCanDuck)
	{
		// g_fOldGravity[activator] = Float:get_entvar(activator, var_gravity);
		// set_entvar(activator, var_gravity, 999999.9);
		flags |= PLAYER_PREVENT_DUCK;
	}
	
	if (g_fCvarMaxSpeed > 0.0)
	{
		if (g_fCvarMaxSpeed <= 1.0)
		{
			flags |= PLAYER_PREVENT_CLIMB;
			set_entvar(activator, var_velocity, NULL_VECTOR);
		}
		
		rg_reset_maxspeed(activator);
	}
	
	if (flags > 0)
	{
		set_entvar(activator, var_iuser3, get_entvar(activator, var_iuser3) | flags);
	}
}

public RT_StopLoot(const corpse_id, const activator, const owner, bool:complete)
{
	if (!is_user_connected(activator))
		return;
	
	if (g_iCvarHookAttack)
	{
		set_member(activator, m_bIsDefusing, false);
	}
	
	new flags;
	if (!g_iCvarCanJump)
	{
		flags |= PLAYER_PREVENT_JUMP;
	}
	
	if (!g_iCvarCanDuck)
	{
		// set_entvar(activator, var_gravity, g_fOldGravity[activator]);
		flags |= PLAYER_PREVENT_DUCK;
	}
	
	if (g_fCvarMaxSpeed > 0.0)
	{
		if (g_fCvarMaxSpeed <= 1.0)
		{
			flags |= PLAYER_PREVENT_CLIMB;
		}
		
		if (is_user_connected(activator))
		{
			rg_reset_maxspeed(activator);
		}
	}
	
	if (flags > 0)
	{
		set_entvar(activator, var_iuser3, get_entvar(activator, var_iuser3) & ~flags);
	}
	
	if (complete)
	{
		rg_add_account(activator, -g_iCvarCost);
		
		//
		if (RT_RelationShipStatus(owner, activator) == GR_TEAMMATE)
		{
			g_playerRevivals[activator]++;
		}
	}
}

public RT_ThinkLoot(const corpse_id, const activator, const owner, Float:time_ending)
{
	if (UTIL_IsRestricted(corpse_id, activator))
	{
		return RT_SUPERCEDE;
	}
	
	return RT_CONTINUE;
}

UTIL_IsRestricted(const corpse_id, const activator)
{
	// Не удержал IN_USE
	if (g_iCvarHoldUse && ~get_entvar(activator, var_button) & IN_USE)
	{
		return true;
	}
	
	// Отвел взгял
	if (g_iCvarViewCone && !ExecuteHam(Ham_FInViewCone, activator, corpse_id))
	{
		return true;
	}
	
	// Раунд окончен
	if (g_iCvarRoundTerminating && get_member_game(m_bRoundTerminating))
	{
		return true;
	}
	
	// На лестнице
	if (g_iCvarOnLadder && get_entvar(activator, var_movetype) == MOVETYPE_FLY)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_ON_LADDER");
		return true;
	}
	
	// В воде
	if (g_iCvarWaterlevel > 0 && get_entvar(activator, var_waterlevel) >= g_iCvarWaterlevel)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_IN_WATER");
		return true;
	}
	
	// Не прошло достаточно времени
	if (!rg_is_time_expired(g_fCvarTimeExpired))
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_TIME_EXPIRED", g_fCvarTimeExpired);
		return true;
	}
	
	// Осталось мало времени
	if (0.0 < rg_get_remaining_time() < g_fCvarTimeRemaining)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_TIME_REMAINING", g_fCvarTimeRemaining);
		return true;
	}
	
	// Не хватает денег
	if (get_member(activator, m_iAccount) < g_iCvarCost)
	{
		UTIL_BlinkAcct(activator, .times = 2, .bAlertMessage = true);
		return true;
	}
	
	// Заложена бомба
	if (g_iCvarBomb && g_pBomb > 0)
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_BOMB");
		return true;
	}
	
	new NumAliveT, NumAliveCT;
	rg_initialize_player_counts(NumAliveT, NumAliveCT, _, _);
	
	// Игроки остались 1 на 1
	if (g_iCvarPlayerDuel && (NumAliveT == 1 && NumAliveCT == 1))
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_DUEL");
		return true;
	}
	
	// Перевес живых оставшихся игроков в команде
	new TeamName:team = get_member(activator, m_iTeam);
	if (g_iCvarPlayerDifference > 0
		&& ((team == TEAM_TERRORIST && (NumAliveT - g_iCvarPlayerDifference >= NumAliveCT))
		|| (team == TEAM_CT && (NumAliveCT - g_iCvarPlayerDifference >= NumAliveT))))
	{
		client_print_color(activator, print_team_red, "%s %l", g_sCvarPrefix, "RT_PLAYERS_DIFF", g_iCvarPlayerDifference);
		return true;
	}
	
	return false;
}

stock UTIL_BlinkAcct(const id, const times, bool:bAlertMessage = false)
{
	static msgBlinkAcct;
	if (msgBlinkAcct > 0 || (msgBlinkAcct = get_user_msgid("BlinkAcct")) > 0)
	{
		message_begin(MSG_ONE_UNRELIABLE, msgBlinkAcct, .player = id);
		write_byte(times);
		message_end();
	}
	
	if (bAlertMessage)
		client_printex(id, print_center, "#Not_Enough_Money");
}

stock TeamName:rg_get_team_wins_row(const wins)
{
	if (get_member_game(m_iNumConsecutiveCTLoses) >= wins)
		return TEAM_TERRORIST;
	else if (get_member_game(m_iNumConsecutiveTerroristLoses) >= wins)
		return TEAM_CT;
	
	return TEAM_UNASSIGNED;
}

stock rg_toggle_flashlight(id, bool:bMode = true)
{
	new flags = get_entvar(id, var_effects);
	set_entvar(id, var_effects, bMode ? (flags |= EF_DIMLIGHT) : (flags &= ~EF_DIMLIGHT));
	
	static msgFlashlight;
	if (msgFlashlight > 0 || (msgFlashlight = get_user_msgid("Flashlight")) > 0)
	{
		message_begin(MSG_ONE, msgFlashlight, .player = id);
		write_byte(_:bMode); // toggle
		write_byte(get_member(id, m_iFlashBattery));
		message_end();
	}
}

stock rg_get_current_round()
{
	return (get_member_game(m_iTotalRoundsPlayed) + 1);
}

stock rg_is_time_expired(Float:sec)
{
	// FIX: m_fRoundStartTime
	return (get_gametime() - Float:get_member_game(m_fRoundStartTimeReal) > sec);
}

stock Float:rg_get_remaining_time()
{
    if (!is_nullent(g_pBomb)) {
        return (Float:get_member(g_pBomb, m_Grenade_flC4Blow) - get_gametime());
    }
    
    return (float(get_member_game(m_iRoundTimeSecs)) - get_gametime() + Float:get_member_game(m_fRoundStartTimeReal));
}

stock bool:rg_is_user_first_spawn(const id)
{
	return (get_member(id, m_iNumSpawns) == 1);
}